{$A+,B-,D-,E-,G-,F-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 2048,0,131072}

USES
  dos;

CONST
  bufsize = 1024*62;
  am: string[54] = 'Simple MS-DOS File Splitter v1.00 (C) 2002 Lidovsky V.';
  h = ^j^m;

VAR
  buf: array [0..bufsize - 1] of byte;
  s: string;
  fulln: pathstr;
  en: extstr;
  fn: namestr;
  dn: string[2];
  fi, fo: file;
  bs: longint;
  i: integer;

PROCEDURE error(n: byte);
  begin
    case n of
      1: writeln('USAGE: dosplit <blocksize, KB> <source filename>',
           h, '  e.g.   dosplit 1400 bigfile.tar.bz2',
           h, '  Blocksize must be greater than 63 KB.');
      2: writeln('Can''t find ', fulln);
      3: writeln('Incorrect blocksize format.');
    end;
    halt(n)
  end;

PROCEDURE init;
  begin
    writeln(am);
    writeln('Use it freely');
    if paramcount <> 2 then
      error(1);
    s := paramstr(1);
    val(s, bs, i);
    if (i > 0) or (bs < 64) then
      error(3);
    bs := bs*1024;
    s := paramstr(2);
    s := fexpand(s);
    if length(s) < 5 then
      error(1);
    fulln := s;
    dn := copy(s, 1, 2);
    fsplit(fulln, s, fn, en);
    if en <> '' then
      delete(en, 1, 1);
    delete(fulln, 1, 2)
  end;

PROCEDURE main;
  var
    l, r: longint;
    bq, i, k: word;
  begin
    assign(fi, dn + fulln);
{$I-}
    reset(fi, 1);
    if ioresult <> 0 then
      error(2);
{$I+}
    l := filesize(fi);
    bq := l div bs;
    if l mod bs > 0 then
      inc(bq);
    for i := 1 to bq do begin
      str(i - 1, s);
      while length(s) < 3 do
        s := '0' + s;
      assign(fo, fn + '.' + s);
      rewrite(fo, 1);
      r := bs;
      if r > l then
        r := l;
      while r > 0 do begin
        k := bufsize;
        if k > r then
          k := r;
        blockread(fi, buf, k);
        blockwrite(fo, buf, k);
        r := r - k;
        l := l - k
      end;
      close(fo)
    end;
    close(fi)
 end;

BEGIN
  init;
  main;
  error(0)
END.

